 ifndef __macros__
__macros__ set 1

; 06/10/96 gb    extract_2_lisptags[.]
; ---- 3.9
; 04/08/96 bill  split (new) restore_saveregs out from vpop_saveregs
; 03/07/96 bill  vref16
; 12/07/95 slh   GB fix to extract_unsigned_byte_bits
; 11/29/95 gb    define jump_fname, jump_nfn macros

  	macro
	lwi &dest,&imm
	if ((((&imm) & 0xffff8000) = 0xffff8000) || (((&imm) & 0xffff8000) = 0))
	 li &dest,&imm
	else
	 lis &dest,&imm>>16
	 if ((&imm) & 0xffff)
	  ori &dest,&dest,(&imm & 0xffff)
	 endif
	endif
	endm

	macro
	extract_fulltag &dest,&tagged_reg
	clrlwi &dest,&tagged_reg,nbits_in_word-ntagbits
	endm

	macro
	extract_lisptag &dest,&tagged_reg
	clrlwi&dot &dest,&tagged_reg,nbits_in_word-nlisptagbits
	endm

	macro
	merge_lisptag &dest,&tagged_reg
	rlwimi&dot &dest,&tagged_reg,nlisptagbits,28,29
	endm

	macro
	extract_2_lisptags &dest,&tagged1,&tagged2
	extract_lisptag &dest,&tagged1
	merge_lisptag&dot &dest,&tagged2
	endm

	macro
	extract_subtag &dest,&misc_obj
	lbz &dest,misc_subtag_offset(&misc_obj)
	endm

	macro
	extract_lowbyte &dest,&src
	clrlwi &dest,&src,nbits_in_word-num_subtag_bits
	endm

	macro
	extract_header &dest,&src
	lwz &dest,misc_header_offset(&src)
	endm
		
	macro
	extract_typecode &dest,&src
	extract_lisptag &dest,&src
	cmpwi cr0,&dest,tag_misc
	bne cr0,@not_misc
	extract_subtag &dest,&src
@not_misc:
	endm
	
	macro
	box_fixnum &boxed,&unboxed
	slwi &boxed,&unboxed,fixnumshift
	endm
	
	macro
	unbox_fixnum &unboxed,&boxed
	srawi &unboxed,&boxed,fixnumshift
	endm

	macro
	loaddf &fpreg,&gpr
	lfd &fpreg,dfloat.value(&gpr)
	endm
	
	macro
	storedf &fpreg,&gpr
	stfd &fpreg,dfloat.value(&gpr)
	endm

	

	macro
	push &src,&stack
	stwu &src,-4(&stack)
	endm
	
	; Generally not a great idea.
	macro
	pop &dest,&stack
	lwz &dest,0(&stack)
	la &stack,4(&stack)
	endm
	
	macro
	vpush &src
	push &src,vsp
	endm
	
	macro
	vpop &dest
	pop &dest,vsp
	endm
	
	macro
	tpush &src
	push &src,tsp
	endm
	
	macro
	unlink &reg
	lwz &reg,0(&reg)
	endm
	
	macro
	set_nargs &n
	lwi nargs,(&n)<<fixnumshift
	endm
	
	macro
	bitclr &dest,&src,&bitnum
	rlwinm &dest,&src,0,0x1f&((31-(&bitnum))+1),0x1f&((31-(&bitnum))-1)
	endm
	

	macro
	vref32 &dest,&src,&n
	lwz &dest,misc_data_offset+((&n)<<2)(&src)
	endm
	
	macro
	vref16 &dest,&src,&n
	lhz &dest,misc_data_offset+((&n)<<1)(&src)
	endm
	
	macro 
	getvheader &dest,&v
	lwz &dest,vector.header(&v)
	endm
	
	; Size is unboxed element count
	macro
	header_size &dest,&header	; dest, header should be untagged registers.
	srwi &dest,&vheader,num_subtag_bits
	endm
	
	; "Length" is fixnum element count
	macro
	header_length &dest,&vheader	; dest: any register; vheader: untagged register
	rlwinm &dest,&vheader,nbits_in_word-(num_subtag_bits-nfixnumtagbits),(num_subtag_bits-nfixnumtagbits),31-nfixnumtagbits
	endm

	macro
	vector_size &dest,&v,&vheader=&dest
	getvheader &vheader,&v
	header_size &dest,&vheader
	endm
	
	macro
	vector_length &dest,&v,&vheader
	getvheader &vheader,&v
	header_length &dest,&vheader
	endm
	
	macro
	ref_global &reg,&glob
	lwz &reg,nrs.globals.&glob(rnil)
	endm
	
	macro
	set_global &reg,&glob
	stw &reg,nrs.globals.&glob(rnil)
	endm

	macro
	ref_nrs_value &reg,&sym
	lwz &reg,((nrs.&sym)+(symbol.vcell))(rnil)
	endm
	
	macro
	set_nrs_value &reg,&sym
	stw &reg,((nrs.&sym)+(symbol.vcell))(rnil)
	endm

	macro
	extract_unsigned_byte_bits &dest,&src,&width
        rlwinm&dot &dest,&src,0,32-fixnumshift,31-(&width+fixnumshift)
	endm
	
	;; vpop argregs; nargs is known to be non-zero
	macro
	vpop_argregs_nz
	cmplwi cr1,nargs,2*4
	vpop arg_z
	blt cr1,@0
	vpop arg_y
	bne cr1,@0
	vpop arg_x
@0:
	endm

	;; vpush argregs
	macro
	vpush_argregs
	cmplwi cr0,nargs,0
	cmplwi cr1,nargs,2*4
	beq cr0,@done
	blt cr1,@z
	beq cr1,@yz
	vpush arg_x
@yz:	vpush arg_y
@z:	vpush arg_z
@done:
	endm
	
	macro
	car &dest,&src
	lwz &dest,cons.car(&src)
	endm
	
	macro
	cdr &dest,&src
	lwz &dest,cons.cdr(&src)
	endm
	
	macro
	rplaca &node,&val
	stw &val,cons.car(&node)
	endm
	
	macro
	rplacd &node,&val
	stw &val,cons.cdr(&node)
	endm
		


	macro
	vpush_saveregs
	vpush save7
	vpush save6
	vpush save5
	vpush save4
	vpush save3
	vpush save2
	vpush save1
	vpush save0
	endm
	
	macro
	restore_saveregs &reg
	lwz save0,0(&reg)
	lwz save1,4(&reg)
	lwz save2,8(&reg)
	lwz save3,12(&reg)
	lwz save4,16(&reg)
	lwz save5,20(&reg)
	lwz save6,24(&reg)
	lwz save7,28(&reg)
	endm

	macro
	vpop_saveregs
	restore_saveregs vsp
	la vsp,32(vsp)
	endm		
	
	macro
	build_lisp_frame
	stwu sp,-lisp_frame.size(sp)
	stw loc_pc,lisp_frame.savelr(sp)
	stw vsp,lisp_frame.savevsp(sp)
	stw fn,lisp_frame.savefn(sp)
	endm
	
	macro
	leaf_trap_unless_fixnum &node,&immtemp,&crf=cr0
	extract_lisptag &immtemp,&node
	cmpwi &crf,&immtemp,tag_fixnum
	beq @ok
	mflr loc_pc
	build_lisp_frame
	bl .SPxuuo_interr
	uuo_interr error_object_not_fixnum,&node
@ok:
	endm
	
	macro
	leaf_trap_unless_list &node,&immtemp,&crf=cr0
	extract_lisptag &immtemp,&node
	cmpwi &crf,&immtemp,tag_list
	beq @ok
	mflr loc_pc
	build_lisp_frame
	bl .SPxuuo_interr
	uuo_interr error_object_not_list,&node
@ok:
	endm

	macro
	leaf_trap_unless_cons &node,&immtemp,&crf=cr0
	extract_fulltag &immtemp,&node
	cmpwi &crf,&immtemp,fulltag_cons
	beq @ok
	mflr loc_pc
	build_lisp_frame
	bl .SPxuuo_interr
	uuo_interr error_object_not_cons,&node
@ok:
	endm

	macro
	leaf_trap_unless_uvector &node,&immtemp,&crf=cr0
	extract_fulltag &immtemp,&node
	cmpwi &crf,&immtemp,fulltag_misc
	beq @ok
	mflr loc_pc
	build_lisp_frame
	bl .SPxuuo_interr
	uuo_interr error_object_not_uvector,&node
@ok:
	endm

;;; freeptr has been advanced, extra register contains lisp_global(HEAP_LIMIT)
	macro 
	leaf_do_xalloc
	cmplw cr6,freeptr,extra
	ble cr6,@no_xalloc
	mflr loc_pc
	build_lisp_frame
	bl .SPfinish_alloc
	lwz loc_pc,lisp_frame.savelr(sp)
	la sp,lisp_frame.size(sp)
	mtlr loc_pc
@no_xalloc:
	endm
	
;;; freeptr has been advanced, extra register contains lisp_global(HEAP_LIMIT)
	macro 
	early_leaf_do_xalloc
	cmplw cr6,freeptr,extra
	ble cr6,@no_xalloc
	build_lisp_frame
	mflr loc_pc
	build_lisp_frame
	bl .SPfinish_alloc
	lwz loc_pc,lisp_frame.savelr(sp)
	la sp,lisp_frame.size(sp)
	mtlr loc_pc
	lwz loc_pc,lisp_frame.savelr(sp)
	la sp,lisp_frame.size(sp)
@no_xalloc:
	endm

	macro
	spentry &name
	export .SP&name
	csect &name{pr}
	function .SP&name
.SP&name:
	endm

;;; "jump" to the code-vector of the function in nfn.
	macro
	jump_nfn
	lwz temp0,_function.codevector(nfn)
	la loc_pc,misc_data_offset(temp0)
	mtctr loc_pc
	bctr
	endm

;;; "jump" to the function in fname's function cell.
	macro
	jump_fname
	lwz nfn,symbol.fcell(fname)
	jump_nfn
	endm

 endif ; __macros__



