/*
File "ccl:lispdcmds:plfun.c" - PPC XLFUN dcmd

Copyright 1990-1994 Apple Computer, Inc.
Copyright 1995 Digitool, Inc.


Modification History

  5/26/95 slh   'not in lfun' msg.
  5/19/95 slh   dcmdScroll initially
*/

#include <Types.h>
#include <LowMem.h>
#include <dcmd.h>
#include "lisp.h"
#include "printsupp.h"

pascal void CommandEntry (dcmdBlock* paramPtr)
{
    long	address;
    Boolean	ok;

    switch (paramPtr->request) {

        case dcmdInit:
            break;

        case dcmdHelp:
            dcmdDrawLine ("\pPLFUN addr");
            dcmdDrawLine ("\p   Displays name of PPC lfun vector at address addr.");
            break;

        case dcmdDoIt:
			(void) dcmdGetNextExpression (&address, &ok);
			if (!ok) {
				dcmdDrawLine ("\pSyntax error");
				return;
			}
			dcmdScroll();
			print_lisp_expression(address, 5);
            break;
    }
} // CommandEntry

// End of plfun.c
