;;; sp_builtin.s - builtin functions support

;;; 02/01/97 gb  more of EQL inline
;;; --- 4.0
;;; 09/07/96 gb  more of LENGTH inline
;;; --- 4.0b1
;;; 06/10/96 gb  new file.

	include 'lisp.s'

	import fixnum_overflow
	macro
	jump_builtin &builtin,&nargs
	ref_nrs_value fname,builtin_functions
	set_nargs &nargs
	vref32 fname,fname,&builtin
	jump_fname
	endm
	
builtin_plus:	spentry builtin_plus
	extract_2_lisptags. imm0,arg_y,arg_z
	bne cr0,@do_call
	mtxer rzero
	addo. arg_z,arg_y,arg_z
	bnslr+
	b fixnum_overflow
@do_call:
	jump_builtin _builtin_plus,2

builtin_minus:	spentry builtin_minus
	extract_2_lisptags. imm0,arg_y,arg_z
	bne cr0,@do_call
	mtxer rzero
	subo. arg_z,arg_y,arg_z
	bnslr+
	b fixnum_overflow
@do_call:
	jump_builtin _builtin_minus,2

builtin_times:	spentry builtin_times
	jump_builtin _builtin_times,2

builtin_div:	spentry builtin_div
	jump_builtin _builtin_div,2

builtin_eq:	spentry builtin_eq
	extract_2_lisptags. imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne cr0,@do_call
	mr arg_z,rnil
	bnelr cr1
	la arg_z,t_offset(rnil)
	blr
@do_call:	
	jump_builtin _builtin_eq,2

builtin_ne:	spentry builtin_ne
	extract_2_lisptags. imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne cr0,@do_call
	mr arg_z,rnil
	beqlr cr1
	la arg_z,t_offset(rnil)
	blr
@do_call:	
	jump_builtin _builtin_ne,2
	
builtin_gt:	spentry builtin_gt
	extract_2_lisptags. imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne cr0,@do_call
	mr arg_z,rnil
	bnglr cr1
	la arg_z,t_offset(rnil)
	blr
@do_call:	
	jump_builtin _builtin_gt,2
	
builtin_ge:	spentry builtin_ge
	extract_2_lisptags. imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne cr0,@do_call
	mr arg_z,rnil
	bltlr cr1
	la arg_z,t_offset(rnil)
	blr
@do_call:	
	jump_builtin _builtin_ge,2
	
builtin_lt:	spentry builtin_lt
	extract_2_lisptags. imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne cr0,@do_call
	mr arg_z,rnil
	bnllr cr1
	la arg_z,t_offset(rnil)
	blr
@do_call:	
	jump_builtin _builtin_lt,2
	
builtin_le:	spentry builtin_le
	extract_2_lisptags. imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne cr0,@do_call
	mr arg_z,rnil
	bgtlr cr1
	la arg_z,t_offset(rnil)
	blr
@do_call:	
	jump_builtin _builtin_le,2
	
	
builtin_eql:	spentry builtin_eql
	cmpw cr0,arg_y,arg_z
	extract_lisptag imm0,arg_y
	extract_lisptag imm1,arg_z
	cmpw cr1,imm0,imm1
	beq cr0,@win
	cmpwi cr0,imm0,tag_misc
	bne cr1,@lose
	bne cr0,@lose
	jump_builtin _builtin_eql,2
@win:	la arg_z,t_offset(rnil)
	blr
@lose:	mr arg_z,rnil
	blr

builtin_length:	spentry builtin_length
	cmpw cr1,arg_z,rnil
	extract_typecode imm0,arg_z
	cmpwi cr0,imm0,min_vector_subtag
	beq cr1,@nil
	beq cr0,@header
	blt cr0,@do_call
	;; (simple-array * (*))
	vector_length arg_z,arg_z,imm0
	blr
@header:
	lwz arg_z,vectorH.logsize(arg_z)
	blr
@nil:
	li arg_z,0
	blr
@do_call:	
	jump_builtin _builtin_length,1

builtin_seqtype: spentry builtin_seqtype
	extract_typecode imm0,arg_z
	cmpwi cr0,imm0,tag_list
	cmpwi cr1,imm1,min_vector_subtag
	beq cr0,@t
	blt cr1,@do_call
	mr arg_z,rnil
	blr
@t:	la arg_z,t_offset(rnil)
	blr
@do_call:
	jump_builtin _builtin_seqtype,1

builtin_assq:	spentry builtin_assq
	jump_builtin _builtin_assq,2

builtin_memq:	spentry builtin_memq
	jump_builtin _builtin_memq,2

builtin_logbitp:	spentry builtin_logbitp
	;; Call out unless both fixnums,0 <=  arg_y < 30
	cmplwi cr1,arg_y,30<<fixnum_shift
	extract_2_lisptags. imm0,arg_y,arg_z
	unbox_fixnum imm0,arg_y
	subfic imm0,imm0,30
	rlwnm imm0,arg_z,imm0,31,31
	rlwimi imm0,imm0,4,27,27
	bnl cr1,@do_call
	bne cr0,@do_call
	add arg_z,rnil,imm0
	blr
@do_call:
	jump_builtin _builtin_logbitp,2
	
builtin_logior:	spentry builtin_logior
	extract_2_lisptags. imm0,arg_y,arg_z
	bne cr0,@do_call
	or arg_z,arg_y,arg_z
	blr
@do_call:
	jump_builtin _builtin_logior,2
	
builtin_logand:	spentry builtin_logand
	extract_2_lisptags. imm0,arg_y,arg_z
	bne cr0,@do_call
	and arg_z,arg_y,arg_z
	blr
@do_call:
	jump_builtin _builtin_logand,2

builtin_ash:	spentry builtin_ash
	jump_builtin _builtin_ash,2

builtin_negate:	spentry builtin_negate
	extract_lisptag. imm0,arg_z
	bne cr0,@do_call
	mtxer rzero
	nego. arg_z,arg_z
	bnslr+
	b fixnum_overflow
@do_call:
	jump_builtin _builtin_negate,1

builtin_logxor:	spentry builtin_logxor
	extract_2_lisptags. imm0,arg_y,arg_z
	bne cr0,@do_call
	xor arg_z,arg_y,arg_z
	blr
@do_call:
	jump_builtin _builtin_logxor,2
	
builtin_aref1:	spentry builtin_aref1
	import .SPsubtag_misc_ref
	extract_typecode imm0,arg_y
	cmpwi cr0,imm0,min_vector_subtag
	box_fixnum arg_x,imm0
	bgt cr0,.SPsubtag_misc_ref
@do_call:
	jump_builtin _builtin_aref1,2

builtin_aset1:	spentry builtin_aset1
	import .SPsubtag_misc_set
	extract_typecode imm0,arg_x
	cmpwi cr0,imm0,min_vector_subtag
	box_fixnum temp0,imm0
	bgt cr0,.SPsubtag_misc_set
@do_call:
	jump_builtin _builtin_aset1,3
